C+    detect_period_test.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM CHECKS WHETHER AUTO HAS FOUND A PERIODIC TRAVELLING
C+    WAVE SOLUTION WITH THE REQUIRED PERIOD. 
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      DIMENSION DARRAY(5)
      CHARACTER*1 ADTECT
      CALL GINFO(INFO)
      OPEN(18,FILE='../temp_files/variables.numbers'
     &,STATUS='OLD')
      REWIND(18)
      READ(18,*)NPDE
      READ(18,*)NPTW
      CLOSE(18)
      IARRAY=MIN(5,NPTW)
C     The significance of iarray is that in the "p." output file, 
C     auto prints up to 5 variable values between the norm and 
C     the period
      OPEN(11,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)
      READ(11,*)
      READ(11,*)
      READ(11,*)NMXHB,NMXPTW,NMXBD,NMXSP,NMXSB,NMXDUM
      CLOSE(11)
      OPEN(12,FILE='fort.7'
     &,STATUS='OLD')
      REWIND(12)
      DO 100 I=1,12
         READ(12,*,END=103)IDUMMY
 100  CONTINUE
      DO 200 I=1,NMXPTW+1
         READ(12,*,END=201)IDUMMY,IPT,ITY,ILAB,PPORC,RNORM,
     &        (DARRAY(JARRAY),JARRAY=1,IARRAY),PERIOD
 200  CONTINUE
      CLOSE(12)
      OPEN(66,FILE='../temp_files/fortran.error'
     &,STATUS='NEW')
      WRITE(66,'(''ERROR: LOOP 200 FINISHED in detect_period_test.f'')')
      CLOSE(66)
      ADTECT='n'
      WRITE(6,9000)ADTECT
      CALL ISTOP(INFO)
 201  CONTINUE
      CLOSE(12)
      CALL DWARN(IPT)
C     Now read in the required value of the period
      OPEN(11,FILE='../temp_files/detect_period_test.input'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)PTARGT,ICP,CPSTRT,CPEND
      CLOSE(11)
C     Now read in tolerances and check whether the period has been reached
      OPEN(16,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      REWIND(16)
      READ(16,*)PPATOL,PPRTOL
      READ(16,*)CATOL,CRTOL
      READ(16,*)PATOL,PRTOL
      CLOSE(16)
      IF (ABS(PATOL).GT.ABS(0.01D0*PTARGT)) THEN
         OPEN(69,FILE='../temp_files/detect.warning1'
     &,STATUS='NEW')
         WRITE(69,'(/,
     &''WARNING: THE VALUE OF periodatol IS RATHER LARGE'',/,
     &''         COMPARED TO THE VALUE OF THE PERIOD.'',/,
     &''         THIS MAY BE APPROPRIATE, BUT IT MIGHT ALSO'',/,
     &''         INDICATE THAT periodatol SHOULD BE REDUCED'',/,
     &''         IN defaults.input''
     &,/)')
         CLOSE(69)
      ENDIF
      PTOL=ABS(PRTOL*PTARGT)+ABS(PATOL)
      IF (ABS(PERIOD-PTARGT).LT.PTOL) THEN
         ADTECT='y'
         IDTECT=0
      ELSE
         ADTECT='n'
C        Now check whether the specified end point was reached
         IF (ICP.EQ.1) THEN
            IF (ABS(PPATOL).GT.ABS(0.01D0*CPEND)) THEN
               OPEN(69,FILE='../temp_files/detect.warning1'
     &              ,STATUS='NEW')
               WRITE(69,'(/,
     &''WARNING: THE VALUE OF controlatol IS RATHER LARGE'',/,
     &''         COMPARED TO THE CONTROL PARAMETER VALUE.'',/,
     &''         AT THE END OF THE SEARCH RANGE.'',/,
     &''         THIS MAY BE APPROPRIATE, BUT IT MIGHT'',/,
     &''         ALSO INDICATE THAT controlatol SHOULD'',/,
     &''         BE REDUCED IN defaults.input''
     &,/)')
               CLOSE(69)
            ENDIF
            TOL=ABS(PPRTOL*CPEND)+ABS(PPATOL)
         ELSE
            IF (ABS(CATOL).GT.ABS(0.01D0*CPEND)) THEN
               OPEN(69,FILE='../temp_files/detect.warning1'
     &              ,STATUS='NEW')
               WRITE(69,'(/,
     &''WARNING: THE VALUE OF speedatol IS RATHER LARGE'',/,
     &''         COMPARED TO THE WAVE SPEED VALUE.'',/,
     &''         AT THE END OF THE SEARCH RANGE.'',/,
     &''         THIS MAY BE APPROPRIATE, BUT IT MIGHT'',/,
     &''         ALSO INDICATE THAT speedatol SHOULD'',/,
     &''         BE REDUCED IN defaults.input''
     &,/)')
               CLOSE(69)
            ENDIF
            TOL=ABS(CRTOL*CPEND)+ABS(CATOL)
         ENDIF
         IF (CPEND.GT.CPSTRT) THEN
            SIGN=1.0D0
         ELSE
            SIGN=-1.0D0
         ENDIF
         IF ((SIGN*PPORC).GT.((SIGN*CPEND)-TOL)) THEN
            IDTECT=5
         ELSE
            IDTECT=4
         ENDIF
      ENDIF
      OPEN(14,FILE='../temp_files/outcome.data'
     &,STATUS='NEW')
      WRITE(14,9001)IDTECT
      CLOSE(14)
      WRITE(6,9000)ADTECT
C     screen output not "message": feeds into a pipe
      CALL ISTOP(INFO)
C-----
 103  CLOSE(12)
      OPEN(66,FILE='../temp_files/fortran.error'
     &,STATUS='NEW')
      WRITE(66,'(''ERROR: FILE 12 HAS NO REAL OUTPUT'',
     &     '' LINES in detect_period_test.f'')')
      CLOSE(66)
      ADTECT='n'
      WRITE(6,9000)ADTECT
      CALL ISTOP(INFO)
 9000 FORMAT(A1)
 9001 FORMAT(I2)
      END

      SUBROUTINE DWARN(IPT)
      IMPLICIT REAL*8 (A-H,K,O-Z)
      LOGICAL DOWARN
      CHARACTER*5 WORD1
      CHARACTER*28 WORD2
      CHARACTER*8 WORD3
      CHARACTER*25 ATYPE
C-----
C      ATYPE='HOPF BIFURCATION POINT.  '
C      ATYPE='PERIODIC TRAVELLING WAVE.'
C      ATYPE='FOLD POINT.              '
C      ATYPE='ECKHAUS POINT.           '
C      ATYPE='HOPF POINT.              '
      ATYPE='SOLN OF THE RIGHT PERIOD.'
C-----
      OPEN(23,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      REWIND(23)
      DO 230 I230=1,11
         READ(23,*)
 230  CONTINUE
      READ(23,*)NWARN1,NWARN2
      CLOSE(23)
      IPT=ABS(IPT)
      DOWARN=.FALSE.
      IF (IPT.LT.NWARN1) THEN
         DOWARN=.TRUE.
         WORD1='SMALL'
         WORD2='JUMPING OVER BIFURCATION PTS'
         WORD3='DECREASE'
      ENDIF
      IF (IPT.GT.NWARN2) THEN
         DOWARN=.TRUE.
         WORD1='LARGE'
         WORD2='UNNECESSARILY LONG RUN TIMES'
         WORD3='INCREASE'
      ENDIF
      IF (DOWARN) THEN
         OPEN(66,FILE='../temp_files/detect.warning'
     &,STATUS='NEW')
         WRITE(66,9000)WORD1,IPT,ATYPE,WORD2,WORD3
         CLOSE(66)
      ENDIF
      RETURN
 9000 FORMAT(/,'WARNING: A RATHER ',A5,' NUMBER OF',
     &     ' CONTINUATION STEPS (=',I5,')',/,
     &     'WAS TAKEN LOOKING FOR THE ',
     &     A25,/,'TO AVOID ',A28,' IT MIGHT BE',
     &     ' HELPFUL TO',/,A8,' THE RELEVANT',
     &     ' ds, dsmin AND dsmax',
     &     ' IN constants.input.',/)
      END
