C+    foldlocus_prepare1.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM GENERATES THE AUTO "r." FILES FOR THE
C+    CALCULATIONS OF A LOCUS OF FOLD IN THE PERIODIC TRAVELLING
C+    WAVE SOLUTION BRANCH.
C+    THERE ARE TWO SEPARATE PROGRAMS: foldlocus_prepare1.f
C+    AND foldlocus_prepare2.f. THE FIRST OF THESE GENERATES
C+    THE "r." FILES FOR LOCATING A FOLD, WHILE
C+    THE SECOND GENERATES THE FILES FOR CONTINUATION OF 
C+    THE FOLD.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
C-----
      OPEN(11,FILE='../temp_files/variables.numbers'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)NPDE
      READ(11,*)NPTW
      CLOSE(11)
C-----
      OPEN(15,FILE='../temp_files/foldlocus_prepare1.input'
     &,STATUS='OLD')
      REWIND(15)
      READ(15,*)IRS,ICP1,CPSTRT,CPEND
      CLOSE(15)
C-----
      OPEN(12,FILE='../temp_files/constants.input'
     &,STATUS='OLD')
      REWIND(12)
      READ(12,*)
      READ(12,*)
      READ(12,*)
      READ(12,*)NTST
      READ(12,*)
      READ(12,*)
      READ(12,*)DS2,DSMIN2,DSMAX2
      CLOSE(12)
C-----
      OPEN(13,FILE='../temp_files/parameter_range.input'
     &,STATUS='OLD')
      REWIND(13)
      READ(13,*)PPMIN,PPMAX
      READ(13,*)CMIN,CMAX
      CLOSE(13)
C-----
      IF (ICP1.EQ.1) THEN
         DSFCTR=1.0D0
      ELSE
         DSFCTR=(CMAX+CMIN)/(ABS(PPMAX)+ABS(PPMIN))
      ENDIF
C-----
      DS2=DS2*DSFCTR
      DSMIN2=DSMIN2*DSFCTR
      DSMAX2=DSMAX2*DSFCTR
C     Note: the input ds values are for pp. Multiplying by dsfctr has
C           the effect of rescaling appropriately if continuation is
C           done with c as the principle continuation parameter.
C-----
      OPEN(11,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)
      READ(11,*)
      READ(11,*)
      READ(11,*)NMX1,NMX2,NDUM1,NDUM2,NDUM3,NMXDUM
      READ(11,*)A0,A1
      READ(11,*)EPSL,EPSU,EPSS
      CLOSE(11)
C-----
      IPS=2
      ILP=0
      NICP=2
      ICP2=11
      NCOL=4
      IAD=3
      ISP=0
      ISW=1
      IPLT=0
      NBC=0
      NINT=0
      NMX51=NMXDUM
C     A few steps, to check the continuation direction
      IF (CPSTRT.LT.CPEND) THEN
         RL0=CPSTRT-0.1D0*(CPEND-CPSTRT)
         RL1=CPEND
         ISIGN=1
      ELSE
         RL0=CPEND
         RL1=CPSTRT+0.1D0*(CPSTRT-CPEND)
         ISIGN=-1
      ENDIF
C     rl0 and rl1 are set in this way because continuation should
C     stop once the continuation parameter reaches its end value; 
C     10% (chosen arbitrarily) of the range is added to the start 
C     value in the opposite direction to the end value to provide
C     a suitable limit in case of an error of some kind -- this 
C     limit should never be reached.
      MXBF=10
      IID=2
      ITMX=8
      ITNW=5
      NWTN=3
      JAC=0
      IADS=1
C-----
      OPEN(21,FILE='r.ptw.51'
     &,STATUS='NEW')
      WRITE(21,'(I8,I2,I8,I2)')NPTW,IPS,IRS,ILP
      WRITE(21,'(3I8)')NICP,ICP1,ICP2
      WRITE(21,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(21,'(I8,4E16.8E2)')NMX51,RL0,RL1,A0,A1
      WRITE(21,'(I8,6I3)')NMX51,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(21,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(21,'(3E16.8E2,I3)')(ISIGN*ABS(DSMIN2)),DSMIN2,DSMAX2,IADS
C     Note: deliberately start at minimum step size.
      WRITE(21,'(''1'',/,''11 0.'',/,''0'',/,''0'')')
      CLOSE(21)
C-----
      ILP=1
c-----
      OPEN(22,FILE='r.ptw.samedirection'
     &,STATUS='NEW')
      WRITE(22,'(I8,I2,I8,I2)')NPTW,IPS,IRS,ILP
      WRITE(22,'(3I8)')NICP,ICP1,ICP2
      WRITE(22,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(22,'(I8,4E16.8E2)')NMX2,RL0,RL1,A0,A1
      WRITE(22,'(I8,6I3)')NMX2,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(22,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(22,'(3E16.8E2,I3)')(ISIGN*ABS(DS2)),DSMIN2,DSMAX2,IADS
      WRITE(22,'(''1'',/,''11 0.'',/,''0'',/,''0'')')
      CLOSE(22)
C-----
      OPEN(23,FILE='r.ptw.otherdirection'
     &,STATUS='NEW')
      WRITE(23,'(I8,I2,I8,I2)')NPTW,IPS,IRS,ILP
      WRITE(23,'(3I8)')NICP,ICP1,ICP2
      WRITE(23,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(23,'(I8,4E16.8E2)')NMX2,RL0,RL1,A0,A1
      WRITE(23,'(I8,6I3)')NMX2,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(23,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(23,'(3E16.8E2,I3)')(-ISIGN*ABS(DS2)),DSMIN2,DSMAX2,IADS
      WRITE(23,'(''1'',/,''11 0.'',/,''0'',/,''0'')')
      CLOSE(23)
C-----
      STOP
      END
