C+    foldlocus_prepare2.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM GENERATES THE AUTO "r." FILES FOR THE
C+    CALCULATIONS OF A LOCUS OF FOLD IN THE PERIODIC TRAVELLING
C+    WAVE SOLUTION BRANCH.
C+    THERE ARE TWO SEPARATE PROGRAMS: foldlocus_prepare1.f
C+    AND foldlocus_prepare2.f. THE FIRST OF THESE GENERATES
C+    THE "r." FILES FOR LOCATING A FOLD, WHILE
C+    THE SECOND GENERATES THE FILES FOR CONTINUATION OF 
C+    THE FOLD.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
C-----
      OPEN(11,FILE='../temp_files/variables.numbers'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)NPDE
      READ(11,*)NPTW
      CLOSE(11)
C-----
      OPEN(14,FILE='../temp_files/foldlocus_prepare2.input'
     &,STATUS='OLD')
      REWIND(14)
      READ(14,*)IRS,ICP1
      CLOSE(14)
C-----
      OPEN(12,FILE='../temp_files/constants.input'
     &,STATUS='OLD')
      REWIND(12)
      READ(12,*)
      READ(12,*)
      READ(12,*)
      READ(12,*)NTST
      READ(12,*)
      READ(12,*)
      READ(12,*)DS2,DSMIN2,DSMAX2
      CLOSE(12)
C-----
      OPEN(11,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)
      READ(11,*)
      READ(11,*)
      READ(11,*)NMX1,NMX2
      READ(11,*)A0,A1
      READ(11,*)EPSL,EPSU,EPSS
      CLOSE(11)
C-----
      OPEN(15,FILE='../temp_files/parameter_range.input'
     &,STATUS='OLD')
      REWIND(15)
      READ(15,*)PPMIN,PPMAX
      READ(15,*)CMIN,CMAX
      CLOSE(15)
C-----
      IF (ICP1.EQ.2) THEN
         ICP2=1
         RL0=CMIN-0.1D0*(CMAX-CMIN)
         RL1=CMAX+0.1D0*(CMAX-CMIN)
         UZ1=PPMIN-0.1D0*(PPMAX-PPMIN)
         UZ2=PPMAX+0.1D0*(PPMAX-PPMIN)
      ELSE
         ICP2=2
         RL0=PPMIN-0.1D0*(PPMAX-PPMIN)
         RL1=PPMAX+0.1D0*(PPMAX-PPMIN)
         UZ1=CMIN-0.1D0*(CMAX-CMIN)
         UZ2=CMAX+0.1D0*(CMAX-CMIN)
      ENDIF
C     Note: in the above, the range is extended by 10% either side of 
C           ppmax/ppmin or cmax/cmin because this makes the plots 
C           look better in some cases.
C-----
      IPS=2
      ILP=0
      NICP=3
      ICP3=11
      ISW=2
      NCOL=4
      IAD=3
      ISP=0
      IPLT=0
      NBC=0
      NINT=0
      NPR2=NMX2
      MXBF=10
      IID=2
      ITMX=8
      ITNW=5
      NWTN=3
      JAC=0
      IADS=1
C-----
      OPEN(60,FILE='r.ptw.60'
     &,STATUS='NEW')
      WRITE(60,'(I8,I2,I8,I2)')NPTW,IPS,IRS,ILP
      WRITE(60,'(4I8)')NICP,ICP1,ICP2,ICP3
      WRITE(60,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
      WRITE(60,'(I8,4E16.8E2)')NMX2,RL0,RL1,A0,A1
      WRITE(60,'(I8,6I3)')NPR2,MXBF,IID,ITMX,ITNW,NWTN,JAC
      WRITE(60,'(3E16.8E2)')EPSL,EPSU,EPSS
      WRITE(60,'(3E16.8E2,I3)')ABS(DS2),DSMIN2,DSMAX2,IADS
      WRITE(60,'(''1'',/,''11 0.'',/,''0'',/,''0'')')
      CLOSE(60)
c-----
      DO 100 IFILE=61,62
         IF (IFILE.EQ.61) THEN
            OPEN(IFILE,FILE='r.ptw.61.draft'
     &,STATUS='NEW')
            JSIGN=+1
         ELSE
            OPEN(IFILE,FILE='r.ptw.62.draft'
     &,STATUS='NEW')
            JSIGN=-1
         ENDIF
         WRITE(IFILE,'(I8,I2,'' IRS '',I2)')NPTW,IPS,ILP
         WRITE(IFILE,'(4I8)')NICP,ICP1,ICP2,ICP3
         WRITE(IFILE,'(I8,5I2,2I8)')NTST,NCOL,IAD,ISP,ISW,IPLT,NBC,NINT
         WRITE(IFILE,'(I8,4E16.8E2)')NMX2,RL0,RL1,A0,A1
         WRITE(IFILE,'(I8,6I3)')NPR2,MXBF,IID,ITMX,ITNW,NWTN,JAC
         WRITE(IFILE,'(3E16.8E2)')EPSL,EPSU,EPSS
         WRITE(IFILE,'(3E16.8E2,I3)')(JSIGN*ABS(DS2)),DSMIN2,DSMAX2,IADS
         WRITE(IFILE,'(''1'',/,''11 0.'',/,''0'',/,''2'')')
         WRITE(IFILE,'(I3,E16.8E2)')(-ICP2),UZ1
         WRITE(IFILE,'(I3,E16.8E2)')(-ICP2),UZ2
         CLOSE(IFILE)
 100  CONTINUE
C-----
      STOP
      END
