C+    test_direction.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM IS USED IN THE CALCULATION OF STABILITY BOUNDARY
C+    CURVES, AND ALSO IN THE CALCULATION OF PERIOD CONTOURS IN THE 
C+    IN WHICH A VALUE OF THE PERIOD IS SPECIFIED. 
C+    THEN A PERIODIC TRAVELLING WAVE IS LOCATED AT A GIVEN STARTING 
C+    PAIR OF CONTROL PARAMETER AND WAVE SPEED VALUES, AND WAVES ARE THEN 
C+    CONTINUED TOWARDS A GIVEN END PAIR, LOOKING EITHER FOR A CHANGE OF 
C+    STABILITY (OF HOPF OR ECKHAUS TYPE) OR FOR A WAVE WITH THE REQUIRED 
C+    PERIOD. FIRST A FEW CONTINUATION STEPS ARE TAKEN WITH ONE SIGN OF 
C+    THE AUTO PARAMETER DS, AND THIS PROGRAM TESTS WHETHER OR NOT THIS 
C+    HAS TAKEN THE CONTINUATION TOWARDS THE GIVEN END POINT.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      CHARACTER*1 AOK
      CALL GINFO(INFO)
      OPEN(11,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)
      READ(11,*)
      READ(11,*)
      READ(11,*)NMXHB,NMXPTW,NMXBD,NMXSP,NMXSB,NMXDUM
      CLOSE(11)
C-----
C     First read in the continuation parameter values 
C       that specify the correct direction
      OPEN(15,FILE='../temp_files/test_direction.input'
     &,STATUS='OLD')
      REWIND(15)
      READ(15,*)CPSTRT,CPRWAY
      CLOSE(15)
C-----
C     Now read in the auto output file
      OPEN(12,FILE='fort.7'
     &,STATUS='OLD')
      REWIND(12)
      DO 600 I=1,12
         READ(12,*,END=103)
 600  CONTINUE
      DO 100 I=1,MAX((NMXDUM+1),10000)
C        The correct max value of I is NMXDUM+1 but I am 
C        including 10000 as a safeguard.
         READ(12,*,END=101)IDUMMY,IPT,ITY,ILAB,CPNEW
         IF (I.EQ.1) THEN
            CPSTRT=CPNEW
         ENDIF
C        Note that this overides the value read in from the
C          file: I added this as a refinement because the actual 
C          starting point for continuation may differ slightly
C          from that specified in the argument list: auto initially
C          looks for a wave with the specified control parameter and
C          wave speed values, but the actual wave found will not
C          have exactly these parameters.
 100  CONTINUE
C-----
      CLOSE(12)
      OPEN(66,FILE='../temp_files/fortran.error'
     &,STATUS='NEW')
      WRITE(66,'(''ERROR: END OF LOOP 100 IN test_direction.f'')')
      CLOSE(66)
      AOK='n'
      WRITE(6,9000)AOK
      CALL ISTOP(INFO)
C-----
 103  CLOSE(12)
      OPEN(66,FILE='../temp_files/fortran.error'
     &,STATUS='NEW')
      WRITE(66,'(''ERROR: FILE 12 HAS INSUFFICIENT OUTPUT'',
     &     ''       LINES in test_direction.f'')')
      CLOSE(66)
      CLOSE(12)
      AOK='n'
      WRITE(6,9000)AOK
      CALL ISTOP(INFO)
C-----
 101  CLOSE(12) 
C     Auto output file is ok, now check direction
      IF (((CPSTRT-CPNEW)*(CPSTRT-CPRWAY)).GT.0.0D0) THEN
         AOK='y'
      ELSE
         AOK='n'
      ENDIF
C-----
      WRITE(6,9000)AOK
C     screen output not "message": feeds into a pipe
C-----
      CALL ISTOP(INFO)
 9000 FORMAT(A1)
      END
