C+    create_shade_sample_data.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM CREATES A DATA FILE GIVING THE OUTLINE OF
C+    THE BOX TO BE SHADED TO PRODUCE A SHADING SAMPLE, FOR 
C+    USE IN THE SHADING KEY.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      OPEN(11,FILE=
     &'../temp_files/create_shade_sample_data.input'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)ILINE,YLSEP,XLLEN,XGLEN,WSCALE
C     ILINE IS LINE NUMBER IN THE KEY
C     YLSEP IS pplanekeylineseparation
C     XLLEN IS pplanekeylinelength
C     XGLEN IS pplanekeygaplength
C     WSCALE IS widthscaling
      CLOSE(11)
      XMID=XGLEN+0.5D0*XLLEN
      YMID=100-(ILINE+0.2)*YLSEP
      XWIDTH=XLLEN*0.8D0
      YWIDTH=YLSEP*0.8D0
      XMID=XMID/WSCALE
      XWIDTH=XWIDTH/WSCALE
      OPEN(12,FILE='../temp_files/shade_sample.data'
     &,STATUS='NEW')
      WRITE(12,9000)(XMID-XWIDTH/2),(YMID-YWIDTH/2)
      WRITE(12,9000)(XMID),(YMID-YWIDTH/2)
      WRITE(12,9000)(XMID+XWIDTH/2),(YMID-YWIDTH/2)
      WRITE(12,9000)(XMID+XWIDTH/2),(YMID)
      WRITE(12,9000)(XMID+XWIDTH/2),(YMID+YWIDTH/2)
      WRITE(12,9000)(XMID),(YMID+YWIDTH/2)
      WRITE(12,9000)(XMID-XWIDTH/2),(YMID+YWIDTH/2)
      WRITE(12,9000)(XMID-XWIDTH/2),(YMID)
      WRITE(12,9000)(XMID-XWIDTH/2),(YMID-YWIDTH/2)
      CLOSE(12)
      OPEN(13,FILE='../temp_files/shade_key_text_location.data'
     &,STATUS='NEW')
      WRITE(13,9000)(XLLEN+2*XGLEN)/WSCALE,YMID
      CLOSE(13)
      STOP
 9000 FORMAT(2E18.10E2)
      END
