C+    get_gamma_limits.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM GETS NEW LIMITS ON gamma FOR PLOTTING,
C+    VIA KEYBOARD INPUT. IT THEN REWRITES THE SPECTRUM DATA
C+    FILE, ONLY INCLUDING ENTRIES WITH gamma VALUES WITHIN
C+    THESE LIMITS.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      OPEN(37,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      READ(37,*)
      READ(37,*)
      READ(37,*)
      READ(37,*)NMXHB,NMXPTW,NMXBD,NMXSP,NMXSB,NMXDUM
      CLOSE(37)
      OPEN(38,FILE='../temp_files/constants.input'
     &,STATUS='OLD')
      DO 200 I200=1,9
         READ(38,*)
 200  CONTINUE
      READ(38,*)NEVALS
      CLOSE(38)
      WRITE(6,9100)
      READ(5,*)G1,G2
      GMIN=MIN(G1,G2)
      GMAX=MAX(G1,G2)
      OPEN(11,FILE='../temp_files/spectrum.plotdata'
     &,STATUS='OLD')
      REWIND(11)
      OPEN(12,FILE='data_files/spectrum.plotdata'
     &,STATUS='NEW')
      DO 100 I=1,(NEVALS*NMXSP+1)
         READ(11,*,END=101)EVR,EVI,IFLAG,GAMMA
         IF ((IFLAG.EQ.0).OR.((GAMMA.GE.GMIN)
     &        .AND.(GAMMA.LE.GMAX))) THEN
            WRITE(12,9000)EVR,EVI,IFLAG,GAMMA
         ENDIF
 100  CONTINUE
      PRINT*,'ERROR IN get_gamma_limits.f'
      PRINT*,'      LOOP 100 FINISHED'
      OPEN(20,FILE='../temp_files/fortran.error'
     &,STATUS='NEW')
      WRITE(20,'(''ERROR'')')
      CLOSE(20)
      STOP
 101  CLOSE(11)
      CLOSE(12)
      STOP
 9000 FORMAT(2E18.10E2,I4,F15.10)
 9100 FORMAT('The plotting flag restrictphasedifference',
     &     ' has been set to "yes".',/,'Enter the required',
     &     ' limits on the phase difference',/,
     &     '  across one period of the wave',
     &     '  for plotting (in either order):')
      END
