#+ bd.gp
# This file was written by Jonathan A. Sherratt
# Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
#  
# THIS FILE IS PART OF WAVETRAIN.
# WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
# AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
# HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
# THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
# THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
# WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
# THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
# OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
# http://www.netlib.org/blas/faq.html#2;
# http://www.netlib.org/lapack/#_licensing; 
# http://www.netlib.org/minpack/disclaimer.
# 
# PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
# COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
# SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
# 
# DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
# A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
# PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
# UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
# PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
# INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
# 
# WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
# THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
# TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
# FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
# LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
# DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
# OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
# LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
# OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
# RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
# WILL BE ERROR-FREE.
#  
#+ THIS gnuplot COMMAND FILE PLOTS BIFURCATION DIAGRAMS.
#++
if ("$#"==0) print "ERROR: no bcode number was given" ; exit
if ("$#">1) print "ERROR: too many arguments: only a bcode number is required" ; exit
unset label
unset xlabel
unset ylabel
unset multiplot ; mpon="no"
unset xzeroaxis
unset yzeroaxis
system "../plotprepare_bd.script ".subdir." ".pdir." $0 ".bdkeylinelength." ".bdkeygaplength
if (system("cat ../temp_files/plotprepare.error") eq "1") exit
title1=titlesexpand.system("getline.script 1 ../temp_files/plotprepare_bd.output").textend
if (system("cat ../temp_files/getline.error") eq "1") exit
title2=titlesexpand.system("getline.script 2 ../temp_files/plotprepare_bd.output").textend
if (system("cat ../temp_files/getline.error") eq "1") exit
xlabeltext=labelsexpand.system("getline.script 3 ../temp_files/plotprepare_bd.output").textend
if (system("cat ../temp_files/getline.error") eq "1") exit
ylabeltext=labelsexpand.system("getline.script 4 ../temp_files/plotprepare_bd.output").textend
if (system("cat ../temp_files/getline.error") eq "1") exit
ncolumns=system("getline.script 5 ../temp_files/plotprepare_bd.output")
if (system("cat ../temp_files/getline.error") eq "1") exit
plotstst=system("getline.script 6 ../temp_files/plotprepare_bd.output")
if (system("cat ../temp_files/getline.error") eq "1") exit
nkeyitems=system("getline.script 7 ../temp_files/plotprepare_bd.output")
if (system("cat ../temp_files/getline.error") eq "1") exit
nkeylines=system("getline.script 8 ../temp_files/plotprepare_bd.output")
if (system("cat ../temp_files/getline.error") eq "1") exit
# Now reset size and origin so that the bounding box includes
#   all of the panels in a postscript file. Note that the
#   term "0.1*(1.0-topspace-bottomspace)" is included based on
#   trial and error, to give a more reliable bounding box
set size 1.0-leftspace-rightspace,1.0-topspace-bottomspace-0.1*(1.0-topspace-bottomspace)
set origin leftspace,bottomspace+0.1*(1.0-topspace-bottomspace)
# Start the plot: using multiplot to allow for the inclusion of a key
set multiplot; mpon="yes"
# Now set up plot geometry and then plot the key, if a key is required
if (nkeyitems>1 && bdkeyspacing>=1) \
 keyheight=(1.0-topspace-bottomspace)*bdkeyheight*nkeylines*0.01 ; \
 plotheight=(1.0-topspace-bottomspace)*(1.0-(bdkeyheight*nkeylines+bdkeyspacing)*0.01) ; \
 set size 1.0-leftspace-rightspace,keyheight ; \
 set origin leftspace,1.0-topspace-keyheight ; \
 system "bd_key.script" ; \
 set xrange [0:100] ; \
 set yrange [83-nkeylines*25:92] ; \
 unset tics
if (nkeyitems>1 && bdkeyspacing>=1) load "../temp_files/bdkey_words.gp"
if (nkeyitems>1 && bdkeyspacing>=1) load "../temp_files/bdkey_lines.gp"
# The above two gnuplot command files generated by bd_key.script
# The plotting of the key is now complete.
if (nkeyitems>1 && bdkeyspacing>=1) \
 unset label ; \
 set size 1.0-leftspace-rightspace,plotheight ; \
 else \
 set size 1.0-leftspace-rightspace,1.0-topspace-bottomspace
set origin leftspace,bottomspace
set tics nooffset
# Read in axes limits and set ranges
xmin=system("getline.script 1 ../temp_files/bd_axes_limits.data")
if (system("cat ../temp_files/getline.error") eq "1") exit
xmax=system("getline.script 2 ../temp_files/bd_axes_limits.data")
if (system("cat ../temp_files/getline.error") eq "1") exit
ymin=system("getline.script 3 ../temp_files/bd_axes_limits.data")
if (system("cat ../temp_files/getline.error") eq "1") exit
ymax=system("getline.script 4 ../temp_files/bd_axes_limits.data")
if (system("cat ../temp_files/getline.error") eq "1") exit
set xrange [xmin:xmax] noreverse writeback
set yrange [ymin:ymax] noreverse writeback
# Set axes labels
set xlabel xlabeltext textcolor rgb "black"
set ylabel ylabeltext textcolor rgb "black"
# Add titles if requested
if (showtitles eq "yes") set label title1 at screen xtitle,(1.0-topspace*0.25) center textcolor rgb "black" \
 offset character 0,(titlesfactor-1.0)*0.5
if (showtitles eq "yes") set label title2 at screen xtitle,(1.0-topspace*0.75) center textcolor rgb "black" \
 offset character 0,(titlesfactor-1.0)*0.5
# Set up labelling of Hopf bifurcation, folds and endpoints
system "bd_labels.script ".showbdlabels." ".foldtextbdexpand." ".textend
if (system("cat ../temp_files/plotprepare.error") eq "1") exit
empty1=system("emptytest.script data_files/hb_and_folds.gpdata")
if (system("cat ../temp_files/emptytest.error") eq "1") exit
labelscmd=""
icolumn=2
if (empty1==1 && ncolumns>1) load "bd_labels.gp"
# Set up drawing of bifurcation curves
linescmd=""
firstword=" "
icolumn=2
system "bd_cleardatafiles.script"
if (ncolumns>1) load "bd_lines.gp" # Note that this will reset the variable "firstword" to " , "
# Set up plotting of steady state, if requested
if (plotstst eq "y") \
 system "selectdata1.script data_files/bd.selectedstst data_files/bd.gpselectedstst" 
if (plotstst eq "y" && system("cat ../temp_files/selectdata.error") eq "1") exit
option="stst"
combi1="bdlinetype".option
combi2="bdlinethickness".option
combi3="bdlinecolour".option
if (plotstst eq "y") \
 ststcmd=firstword.'"data_files/bd.gpselectedstst" using 1:2 with lines '.@combi1.' '.@combi2.' linecolor '.@combi3 ; \
 else \
 ststcmd=""
# Finally, issue plot command
plot@linescmd@ststcmd@labelscmd
iline=0 # This initialises the counter
ilpf=0 # This initialises the counter
# END OF FILE
