C+    calcboundingbox.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM CALCULATES THE CORRECT BOUNDING BOX FOR
C+    A POSTSCRIPT FILE GENERATED BY gnuplot. THE FILE
C+    data_files/calcboundingbox.input CONTAINS THE FOUR REAL 
C+    NUMBERS bottomspace, leftspace, rightspace, topspace
C+    (IN THAT ORDER) AND THE FILE bb.txt CONTAINS THE 
C+    BOUNDING BOX GENERATED BY gnuplot.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      REAL*8 LSPACE
      INTMIN=-9999
      INTMAX=99999
C     The variables INTMIN and INTMAX are the max and min
C       values that will fit the format statement used 
C       for writing the new bounding box.
      OPEN(11,FILE='data_files/calcboundingbox.input',
     &STATUS='OLD')
      REWIND(11)
      READ(11,*)BSPACE,LSPACE,RSPACE,TSPACE
      CLOSE(11)
C     Note that BSPACE,LSPACE,RSPACE,TSPACE are only
C       used if IWHICH=1
      OPEN(12,FILE='data_files/bb.txt',STATUS='OLD')
      REWIND(12)
      READ(12,*)I1,J1,I2,J2
      CLOSE(12)
      OPEN(13,FILE='data_files/calcboundingbox.iwhich',
     &STATUS='OLD')
      REWIND(13)
      READ(13,*)IWHICH
      CLOSE(13)
      IMIN=MIN(I1,I2)
      IMAX=MAX(I1,I2)
      JMIN=MIN(J1,J2)
      JMAX=MAX(J1,J2)
      XSCALE=(IMAX-IMIN)/(1.0D0-LSPACE-RSPACE)
      YSCALE=(JMAX-JMIN)/(1.0D0-TSPACE-BSPACE)
      IF (IWHICH.EQ.1) THEN
         IMIN1=IMIN-INT(XSCALE*LSPACE)-1
         IMAX1=IMAX+INT(XSCALE*RSPACE)+1
         JMIN1=JMIN-INT(YSCALE*BSPACE)-1
         JMAX1=JMAX+INT(YSCALE*TSPACE)+1
      ENDIF
      IF (IWHICH.EQ.2) THEN
         IMIN1=IMIN-INT(0.02D0*(IMAX-IMIN))-1
         IMAX1=IMAX+INT(0.02D0*(IMAX-IMIN))+1
         JMIN1=JMIN-INT(0.02D0*(JMAX-JMIN))-1
         JMAX1=JMAX+INT(0.02D0*(JMAX-JMIN))+1
      ENDIF
      IF (IWHICH.EQ.3) THEN
         OPEN(20,FILE='data_files/create_box_data.output',
     &STATUS='OLD')
         REWIND(20)
         READ(20,*)XX1BOX,YY1BOX,XX2BOX,YY2BOX
         CLOSE(20)
         X1BOX=MIN(XX1BOX,XX2BOX)
         X2BOX=MAX(XX1BOX,XX2BOX)
         Y1BOX=MIN(YY1BOX,YY2BOX)
         Y2BOX=MAX(YY1BOX,YY2BOX)
         IMIN2=IMIN+INT((IMAX-IMIN)*X1BOX*0.01D0)
         IMAX2=IMIN+INT((IMAX-IMIN)*X2BOX*0.01D0)+1
         JMIN2=JMIN+INT((JMAX-JMIN)*Y1BOX*0.01D0)
         JMAX2=JMIN+INT((JMAX-JMIN)*Y2BOX*0.01D0)+1
         IMIN1=IMIN2-INT(0.02D0*(IMAX2-IMIN2))-1
         IMAX1=IMAX2+INT(0.02D0*(IMAX2-IMIN2))+1
         JMIN1=JMIN2-INT(0.02D0*(JMAX2-JMIN2))-1
         JMAX1=JMAX2+INT(0.02D0*(JMAX2-JMIN2))+1
      ENDIF
      IF (
     &(IMIN1.LT.INTMIN).OR.(IMAX1.GT.INTMAX)
     &.OR.
     &(JMIN1.LT.INTMIN).OR.(JMAX1.GT.INTMAX)
     &) THEN
         WRITE(6,9001)
      ELSE
         OPEN(14,FILE='data_files/calcboundingbox.output',
     &STATUS='NEW')
         WRITE(14,9000)IMIN1,JMIN1,IMAX1,JMAX1
         CLOSE(14)
      ENDIF
      STOP
 9000 FORMAT(4I6)
 9001 FORMAT('ERROR: when trying to change the bounding box',/,
     &       '       in the postscript file, the coordinates',/,
     &       '       that have been calculated for the new',/,
     &       '       bounding box are too big in absolute',/,
     &       '       value for the format statement being',/,
     &       '       used. Therefore the postscript file',/,
     &       '       has not been changed.')
      END
