#+ period_contour.gp
# This file was written by Jonathan A. Sherratt
# Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
#  
# THIS FILE IS PART OF WAVETRAIN.
# WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
# AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
# HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
# THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
# THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
# WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
# THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
# OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
# http://www.netlib.org/blas/faq.html#2;
# http://www.netlib.org/lapack/#_licensing; 
# http://www.netlib.org/minpack/disclaimer.
# 
# PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
# COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
# SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
# 
# DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
# A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
# PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
# UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
# PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
# INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
# 
# WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
# THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
# TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
# FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
# LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
# DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
# OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
# LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
# OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
# RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
# WILL BE ERROR-FREE.
#  
#+ THIS gnuplot COMMAND FILE PLOTS PERIOD CONTOURS (INCLUDING
#+ THOSE DESIGNATED TO BE LOCI OF HOMOCLINIC SOLUTIONS).
#+ THERE IS ONE ARGUMENT, WHICH IS EITHER A ccode NUMBER
#+ OR all/All/ALL; IN THE LATTER CASE, CONTOURS CORRESPONDING
#+ TO ALL ccode VALUES ARE PLOTTED.
#++
if ("$#"==0) print "ERROR: no rcode number was given" ; exit
if ("$#">1) print "ERROR: too many arguments: only an rcode number is required" ; exit
ipc=ipc+1
system "../plotprepare_pc.script ".gprintf("%18.10g",xperiodcontourlabelbox)." ".gprintf("%18.10g",yperiodcontourlabelbox)." ".pdir." $0 ".showperiodcontourlabels." ".periodcontourlabelsstyle." ".periodcontourlabelsdps." ".gprintf("%18.10g",GPVAL_X_MIN)." ".gprintf("%18.10g",GPVAL_X_MAX)." ".gprintf("%18.10g",GPVAL_Y_MIN)." ".gprintf("%18.10g",GPVAL_Y_MAX)
if (system("cat ../temp_files/plotprepare.error") eq "1") exit
# Now split up the data file into homoclinic and non-homoclinic parts
system "selectdata2.script data_files/periodcontour.contourdata data_files/periodcontour.gpdata1_".ipc
if (system("cat ../temp_files/selectdata.error") eq "1") exit
system "selectdata3.script data_files/periodcontour.contourdata data_files/periodcontour.gpdata2_".ipc
if (system("cat ../temp_files/selectdata.error") eq "1") exit
# Now generate the plot commands for the lines
empty1=system("emptytest.script data_files/periodcontour.gpdata1_".ipc)
if (system("cat ../temp_files/emptytest.error") eq "1") exit
empty2=system("emptytest.script data_files/periodcontour.gpdata2_".ipc)
if (system("cat ../temp_files/emptytest.error") eq "1") exit
if (empty1==0) cmd1="" ;\
 else cmd1=' "data_files/periodcontour.gpdata1_'.ipc.'" using 1:2 with lines '.periodcontourlinetype.' '.periodcontourlinethickness.' linecolor '.periodcontourcolour
if (empty2==0) cmd2="" ;\
 else cmd2=' "data_files/periodcontour.gpdata2_'.ipc.'" using 1:2 with lines '.homocliniclinetype.' '.homocliniclinethickness.' linecolor '.homocliniccolour
if (empty1==1 && empty2==1) end1="," ; else end1=""
# Now rewrite the data files for the labels
system "selectdata.script data_files/periodcontour.newlabels data_files/periodcontour.gplabels_".ipc." \
 '$$c1 $$c2 \\\"".periodcontourlabelsexpand."$$c4".textend."\\\"' '$$c6 -eq 0 -a $$c3 -gt 0'"
if (system("cat ../temp_files/selectdata.error") eq "1") exit
# Note that the iorientation flag (column 3) does contain orientation
#   info if it is positive, but this is used to reposition the label
#   in reformat_labels_pc.f; they should then be centred on the 
#   label location.
empty3=system("emptytest.script data_files/periodcontour.gplabels_".ipc)
if (system("cat ../temp_files/emptytest.error") eq "1") exit
if (empty3==0 || showperiodcontourlabels ne "yes") cmd3="" ;\
 else cmd3=', "data_files/periodcontour.gplabels_'.ipc.'" using 1:2:3 with labels textcolor '.periodcontourcolour
# Finally, the plot command
call "reset_output.gp"
replot @cmd1@end1@cmd2@cmd3
