#+ pplane_key_nextitem.gp
# This file was written by Jonathan A. Sherratt
# Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
#  
# THIS FILE IS PART OF WAVETRAIN.
# WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
# AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
# HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
# THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
# THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
# WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
# THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
# OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
# http://www.netlib.org/blas/faq.html#2;
# http://www.netlib.org/lapack/#_licensing; 
# http://www.netlib.org/minpack/disclaimer.
# 
# PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
# COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
# SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
# 
# DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
# A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
# PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
# UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
# PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
# INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
# 
# WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
# THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
# TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
# FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
# LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
# DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
# OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
# LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
# OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
# RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
# WILL BE ERROR-FREE.
#  
#+ THIS gnuplot COMMAND FILE GENERATES THE NEXT SYMBOL/LINE AND
#+ ACCOMPANYING TEXT FOR THE KEY FOR PARAMETER PLANE PLOTS.
#++
outcome=word(pplanekeylist,ikey)
ikey=ikey+1
if (outcome==4 || outcome==5) check4and5=check4and5+1
if (check4and5==2 && pplanekeytype==2 && ikey<=nkey) check4and5=3; reread
if (check4and5==2 && pplanekeytype==2 && ikey>nkey) exit
system "../plotprepare_pplane_key.script ".outcome." ".pplanekeytype." ".ifirst
ifirst=1
if (system("cat ../temp_files/plotprepare.error") eq "1") exit
keytextin=system("getline.script 1 ../temp_files/plotprepare_pplane_key.output")
keytext=pplanekeytextexpand.keytextin.textend
if (system("cat ../temp_files/getline.error") eq "1") exit
keyctypename=system("getline.script 2 ../temp_files/plotprepare_pplane_key.output")
if (system("cat ../temp_files/getline.error") eq "1") exit
keyptypename=system("getline.script 3 ../temp_files/plotprepare_pplane_key.output")
if (system("cat ../temp_files/getline.error") eq "1") exit
keylweightname=system("getline.script 4 ../temp_files/plotprepare_pplane_key.output")
if (system("cat ../temp_files/getline.error") eq "1") exit
keyltypename=system("getline.script 5 ../temp_files/plotprepare_pplane_key.output")
if (system("cat ../temp_files/getline.error") eq "1") exit
y=y-pplanekeylineseparation
labelcmd1="" 
# This dummy value is needed if the first outcome is >5, even though @labelcmd1 is not actually used
if (outcome<=5) \
  labelcmd1="set label at xpoint,y point ".@keyptypename." pointsize pplanekeysymbolssize linecolor ".@keyctypename
if (outcome<=5) @labelcmd1 ; else system "create_line_data.script \
 data_files/keyline.data_".outcome." ".gprintf("%18.10g",xline1)." ".gprintf("%18.10g",y)." ".gprintf("%18.10g",xline2)." ".gprintf("%18.10g",y) ; \
 keylinecmd=keylinecmd.', "data_files/keyline.data_'.outcome.'" using 1:2 with lines '.@keyltypename.' '.@keylweightname.' linecolor '.@keyctypename
labelcmd2="set label keytext at xtext,y left textcolor ".@keyctypename." nopoint"
@labelcmd2
nchars=strlen(keytextin)
if (nchars>ncharsmax) ncharsmax=nchars
if (ikey<=nkey) reread
