#+ set_colours.gp
# This file was written by Jonathan A. Sherratt
# Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
#  
# THIS FILE IS PART OF WAVETRAIN.
# WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
# AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
# HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
# THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
# THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
# WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
# THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
# OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
# http://www.netlib.org/blas/faq.html#2;
# http://www.netlib.org/lapack/#_licensing; 
# http://www.netlib.org/minpack/disclaimer.
# 
# PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
# COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
# SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
# 
# DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
# A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
# PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
# UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
# PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
# INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
# 
# WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
# THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
# TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
# FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
# LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
# DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
# OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
# LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
# OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
# RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
# WILL BE ERROR-FREE.
#  
#+ THIS gnuplot COMMAND FILE CREATES A POSTSCRIPT 
#+ FILE IN WHICH THE COLOURS ARE LISTED BY NAME. IT IS RUN 
#+ (WITH ARGUMENT=1) WHEN THE PLOTTER IS STARTED UP.
#+ COLOURS ARE SPECIFIED IN ../list_of_colours.txt
#+ IF THIS FILE IS EDITTED THEN set_colours MUST BE RUN IN ORDER 
#+ FOR THE CHANGES TO TAKE EFFECT.
#+ NOTE THAT THE FIRST COLOUR IN THE FILE list_of_colours.txt
#+ IS THE DEFAULT COLOUR, WHICH IS NOT INCLUDED IN THE LIST
#+ PRODUCED BY THIS COMMAND.
#++
unset label
unset xlabel
unset ylabel
unset multiplot ; mpon="no"
unset xzeroaxis
unset yzeroaxis
set tics nooffset
system "../plotprepare_set_colours_gnuplot.script"
if (system("cat ../temp_files/plotprepare.error") eq "1") exit
ncolours=system("getline.script 1 ../temp_files/plotprepare_set_colours_gnuplot.output")
if (system("cat ../temp_files/getline.error") eq "1") exit
nrows=system("getline.script 2 ../temp_files/plotprepare_set_colours_gnuplot.output")
if (system("cat ../temp_files/getline.error") eq "1") exit
ncolumns=system("getline.script 3 ../temp_files/plotprepare_set_colours_gnuplot.output")
if (system("cat ../temp_files/getline.error") eq "1") exit
system "../filerm.script ../../postscript_files/colour_list.ps"
system "../filerm.script ../../postscript_files/colour_list.eps"
set terminal postscript eps color size 7in,10in enhanced "Helvetica" 20
set output "../../postscript_files/colour_list.eps"
call "data_files/textexpand_ps.gp"
call "data_files/textfactors_ps.gp"
call "data_files/textmisc_ps.gp"
set size 0.9,0.9
set origin 0.05,0.05
set xrange [0.49:(ncolumns+0.51)]
set yrange [-0.51:(nrows+1.51)]
icolour=2 # first colour is the default; not shown in postscript file
icolumn=1
irow=1
load "set_colours_nextcolour.gp"
unset tics
plot "data_files/set_colours_box.data" using ( 0.5+column(1) ):( 0.5+column(2) ) with lines linecolor rgb "black" linewidth 1.0
set tics
unset label
unset object
set xrange [-10:10]
set yrange [-10:10]
set xrange [*:*] noreverse nowriteback
set yrange [*:*] noreverse nowriteback
unset origin
unset size
call "screen.gp"
system "fixboundingbox.script ".gprintf("%9.6f",bottomspace)." ".gprintf("%9.6f",leftspace)." ".gprintf("%9.6f",rightspace)." ".gprintf("%9.6f",topspace)." 2"