#+ shade_key_nextitem.gp
# This file was written by Jonathan A. Sherratt
# Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
#  
# THIS FILE IS PART OF WAVETRAIN.
# WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
# AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
# HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
# THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
# THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
# WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
# THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
# OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
# http://www.netlib.org/blas/faq.html#2;
# http://www.netlib.org/lapack/#_licensing; 
# http://www.netlib.org/minpack/disclaimer.
# 
# PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
# COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
# SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
# 
# DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
# A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
# PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
# UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
# PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
# INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
# 
# WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
# THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
# TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
# FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
# LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
# DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
# OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
# LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
# OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
# RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
# WILL BE ERROR-FREE.
#  
#+ THIS gnuplot COMMAND FILE GENERATES THE NEXT SHADING SAMPLE
#+ AND ACCOMPANYING TEXT FOR THE KEY FOR PARAMETER PLANE PLOTS.
#++
system "../plotprepare_shade_key2.script ".ikey." ".pplanekeylineseparation." ".pplanekeylinelength." ".pplanekeygaplength." ".gprintf("%18.10g",widthscaling)
if (system("cat ../temp_files/plotprepare.error") eq "1") exit
keycolourword=system("getline.script 1 ../temp_files/shade_key_thisline.colour")
if (system("cat ../temp_files/getline.error") eq "1") exit
keycolour=system("translate_colour.script wtc".keycolourword)
if (system("cat ../temp_files/translate_colour.error") eq "1") exit
keytype=system("getline.script 1 ../temp_files/shade_key_thisline.type")
if (system("cat ../temp_files/getline.error") eq "1") exit
keytextin=system("getline.script 1 ../temp_files/shade_key_thisline.text")
keytext=pplanekeytextexpand.keytextin.textend
if (system("cat ../temp_files/getline.error") eq "1") exit
y=y-pplanekeylineseparation
set label keytext at xtext,y left textcolor rgb "black" nopoint
nchars=strlen(keytextin)
if (nchars>ncharsmax) ncharsmax=nchars
shadecmd1="set style fill pattern ".keytype." noborder"
@shadecmd1
shadecmd2=', "../temp_files/shade_sample.data'.ikey.'" using 1:2 with filledcurves linecolor rgb "'.keycolour.'" fillstyle pattern '.keytype.' noborder'
shadecmd3=', "../temp_files/shade_sample.data'.ikey.'" using 1:2 with lines '.linethickness.' linetype -1 linecolor rgb "black"'
if (keytype>0) minirectanglescmd=minirectanglescmd.shadecmd2.shadecmd3
ikey=ikey+1
if (ikey<=nkey) reread
