C+    redo_contourdata_pc_1.f   
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    IF DEFAULT LABELLING IS SELECTED FOR PERIOD CONTOURS (I.E. 
C+    LABELS WHERE THE CONTOUR/CONTOURS CROSSES/CROSS THE EDGE OF
C+    THE PLOTTING REGION, THEN THIS PROGRAM IS RUN. IT REMOVES 
C+    DATA POINTS THAT LIE OUTSIDE, OR JUST INSIDE, THE PLOTTING
C+    REGION. NOTE THAT THIS PROGRAM IS RUN IN ADDITION TO (AND
C+    BEFORE) redo_contourdata_pc_2.f
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      LOGICAL PLT
C     Note: the temp_files directory referred to below
C           is a subdirectory of plotting, while the
C           data_files directory is a subsubdirectory
C           of plotting.
      OPEN(37,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      READ(37,*)
      READ(37,*)
      READ(37,*)
      READ(37,*)NMXHB,NMXPTW,NMXBD,NMXSP,NMXSB,NMXDUM
      CLOSE(37)
      OPEN(15,FILE='../temp_files/periodlabelbox.data'
     &,STATUS='OLD')
      REWIND(15)
      READ(15,*)XPLBOX,YPLBOX
      CLOSE(15)
      OPEN(14,FILE='../temp_files/xyrange.data'
     &,STATUS='OLD')
      READ(14,*)PPMIN,PPMAX,CMIN,CMAX
      CLOSE(14)
      PPGAP=XPLBOX*(PPMAX-PPMIN)
      CGAP=YPLBOX*(CMAX-CMIN)
      OPEN(11,FILE='data_files/periodcontour.contourdata'
     &,STATUS='OLD')
      REWIND(11)
      OPEN(12,FILE='data_files/periodcontour.contourdata1'
     &,STATUS='NEW')
      DO 200 I=1,((2*NMXPTW+2)*899+1)
C     899 is the maximum number of possible pcode values
         READ(11,*,END=201)PP,C,I01,IHC
         PLT=.TRUE.
         IF ((I01.NE.0).AND.(IHC.EQ.0)) THEN
            IF (PP.GT.(PPMAX-0.5D0*PPGAP)) THEN
               PLT=.FALSE.
            ENDIF
            IF (PP.LT.(PPMIN+0.5D0*PPGAP)) THEN
               PLT=.FALSE.
            ENDIF
            IF (C.GT.(CMAX-0.5D0*CGAP)) THEN
               PLT=.FALSE.
            ENDIF
            IF (C.LT.(CMIN+0.5D0*CGAP)) THEN
               PLT=.FALSE.
            ENDIF
         ENDIF
         IF (PLT) THEN
            WRITE(12,9000)PP,C,I01,IHC
         ENDIF
 200  CONTINUE
      WRITE(6,'(''ERROR:'',
     &'' LOOP 200 FINISHED in redo_contourdata_pc_1.f'')')
 201  CLOSE(11)
      CLOSE(12)
      STOP
 9000 FORMAT(2E18.10E2,2I2)
      END
