C+    shade_test_orientation_start.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    This program determines whether the orientation of the 
C+    data file for the first bounding curve needs to be reversed
C+    before it is included in the main data file for shading.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      OPEN(11,FILE=
     &'data_files/shade.data.curve1.firstline'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)PP1,C1
      CLOSE(11)
      OPEN(12,FILE=
     &'data_files/shade.data.curve1.lastline'
     &,STATUS='OLD')
      REWIND(12)
      READ(12,*)PP2,C2
      CLOSE(12)
      OPEN(13,FILE=
     &'data_files/shade.data.curve2.firstline'
     &,STATUS='OLD')
      REWIND(13)
      READ(13,*)PP3,C3
      CLOSE(13)
      OPEN(14,FILE=
     &'data_files/shade.data.curve2.lastline'
     &,STATUS='OLD')
      REWIND(14)
      READ(14,*)PP4,C4
      CLOSE(14)
C
      DIST13=SQRT((PP1-PP3)*(PP1-PP3)+(C1-C3)*(C1-C3))
      DIST23=SQRT((PP2-PP3)*(PP2-PP3)+(C2-C3)*(C2-C3))
      DIST14=SQRT((PP1-PP4)*(PP1-PP4)+(C1-C4)*(C1-C4))
      DIST24=SQRT((PP2-PP4)*(PP2-PP4)+(C2-C4)*(C2-C4))
      DIST1=MIN(DIST13,DIST14)
      DIST2=MIN(DIST23,DIST24)
C
      IF (DIST1.LT.DIST2) THEN
         IOUT=1
      ELSE
         IOUT=0
      ENDIF
C
      OPEN(15,FILE=
     &'data_files/shade_test_orientation_start.output'
     &,STATUS='NEW')
      WRITE(15,9000)IOUT
      CLOSE(15)
      STOP
 9000 FORMAT(I1)
      END
