C+    bd_part.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM IS COMBINED WITH equations.f TO FORM THE MAIN
C+    AUTO PROGRAM FOR BIFURCATION DIAGRAM CALCULATIONS, FOR THE
C+    CASE OF SOLUTION BRANCHES STARTING AT HOPF BIFURCATION POINTS.
C++
C----------------------------------------------------------------------
      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION U(NDIM),PAR(*),F(NDIM),ICP(*)
      CALL TWEQS(NDIM,PAR(1),PAR(2),U,F)
      RETURN
      END
C----------------------------------------------------------------------
      SUBROUTINE STPNT(NDIM,U,PAR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION U(NDIM),PAR(*)
      LOGICAL EXISTS
      OPEN(12,FILE='../temp_files/arguments.data'
     &,STATUS='OLD')
      REWIND(12)
      READ(12,*)ICP
      READ(12,*)FIXED
      CLOSE(12)
      OPEN(13,FILE='../temp_files/bd.range'
     &,STATUS='OLD')
      REWIND(13)
      READ(13,*)PPMIN,PPMAX
      READ(13,*)CMIN,CMAX
      CLOSE(13)
      IF (ICP.EQ.1) THEN
         PAR(1)=PPMIN
         PAR(2)=FIXED
      ELSE
         PAR(1)=FIXED
         PAR(2)=CMIN
      ENDIF
      EXISTS=.FALSE.
      CALL STST(NDIM,PAR(1),PAR(2),U,EXISTS)
C     Now check whether PAR(1) was changed by STST in order
C     to get a steady state: this is not allowed if the value 
C     of pp is fixed.
      IF ((ICP.EQ.2).AND.(PAR(1).NE.FIXED)) THEN
         PRINT *,'Problem (in bd_part.f):'
         PRINT *,'  there is no steady state for the'
         PRINT *,'  specified value of the control parameter.'
C        Note: it is appropriate to use a print statement here rather
C              than info routines since this code will be run by auto
         OPEN(14,FILE='../temp_files/auto_stst.error',STATUS='NEW')
         WRITE(14,'(''There is no steady state for this'')')
         WRITE(14,'(''value of the control parameter.'')')
         CLOSE(14)
      ENDIF
      RETURN
      END
C----------------------------------------------------------------------
      SUBROUTINE BCND 
      RETURN 
      END 
C----------------------------------------------------------------------
      SUBROUTINE ICND 
      RETURN 
      END 
C---------------------------------------------------------------------- 
      SUBROUTINE FOPT 
      RETURN 
      END 
C----------------------------------------------------------------------
      SUBROUTINE PVLS(NDIM,U,PAR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION U(NDIM),PAR(*)
      OPEN(11,FILE='../temp_files/variable.data'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)IVAR
      CLOSE(11)
      PAR(3)=GETP('MAX',IVAR,U)
      PAR(4)=GETP('INT',IVAR,U)
      PAR(5)=GETP('MIN',IVAR,U)
      PAR(6)=GETP('NRM',IVAR,U)
      RETURN
      END
C----------------------------------------------------------------------
