C+    detect_hb_bd.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM CHECKS WHETHER AUTO HAS DETECTED A HOPF 
C+    BIFURCATION IN THE TRAVELLING WAVE EQUATIONS. 
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      CALL GINFO(INFO) 
      ZERO=0.0D0
      IZERO=0
      IONE=1
      OPEN(11,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)
      READ(11,*)
      READ(11,*)
      READ(11,*)NMXHB,NMXPTW,NMXBD,NMXSP,NMXSB,NMXDUM
      CLOSE(11)
      OPEN(12,FILE='fort.7'
     &,STATUS='OLD')
      REWIND(12)
      OPEN(13,FILE='data_files/bd.newstst'
     &,STATUS='NEW')
      WRITE(13,9000)ZERO,ZERO,ZERO,IZERO
      DO 100 I=1,12
         READ(12,*)
 100  CONTINUE
      NHB=0
      DO 200 I=1,NMXHB+1
         READ(12,*,END=201)IDUMMY,IPT,ITY,ILAB,PP,RNORM,
     &        RMAXU,DUMMY,UMAX,UMEAN,UMIN,UNORM
C     NOTE: umax, umin, umean and unorm are all the same 
C           since steady state
         WRITE(13,9000)PP,RNORM,UMAX,IONE
         IF (ITY.EQ.3) THEN
            NHB=NHB+1
         ENDIF
 200  CONTINUE
      OPEN(66,FILE='../temp_files/fortran.error'
     &,STATUS='NEW')
      WRITE(66,'(''ERROR: END OF LOOP 200 IN detect_hb_bd.f'')')
      CLOSE(66)
      CLOSE(12)
      NHB=0
      WRITE(6,9001)NHB
      CALL ISTOP(INFO)
 201  CLOSE(12)
      CALL DWARN(IPT)
      WRITE(6,9001)NHB
C     screen output not "message": feeds into a pipe
      CALL ISTOP(INFO)
 9000 FORMAT(3E18.10E2,I2)
 9001 FORMAT(I8)
      END

      SUBROUTINE DWARN(IPT)
      IMPLICIT REAL*8 (A-H,K,O-Z)
      LOGICAL DOWARN
      CHARACTER*5 WORD1
      CHARACTER*28 WORD2
      CHARACTER*8 WORD3
      CHARACTER*25 ATYPE
C-----
      ATYPE='HOPF BIFURCATION POINT.  '
C      ATYPE='PERIODIC TRAVELLING WAVE.'
C      ATYPE='FOLD POINT.              '
C      ATYPE='ECKHAUS POINT.           '
C      ATYPE='HOPF POINT.              '
C      ATYPE='SOLN OF THE RIGHT PERIOD.'
C-----
      OPEN(23,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      REWIND(23)
      DO 230 I230=1,11
         READ(23,*)
 230  CONTINUE
      READ(23,*)NWARN1,NWARN2
      CLOSE(23)
      IPT=ABS(IPT)
      DOWARN=.FALSE.
      IF (IPT.LT.NWARN1) THEN
         DOWARN=.TRUE.
         WORD1='SMALL'
         WORD2='JUMPING OVER BIFURCATION PTS'
         WORD3='DECREASE'
      ENDIF
      IF (IPT.GT.NWARN2) THEN
         DOWARN=.TRUE.
         WORD1='LARGE'
         WORD2='UNNECESSARILY LONG RUN TIMES'
         WORD3='INCREASE'
      ENDIF
      IF (DOWARN) THEN
         OPEN(66,FILE='../temp_files/detect.warning'
     &,STATUS='NEW')
         WRITE(66,9000)WORD1,IPT,ATYPE,WORD2,WORD3
         CLOSE(66)
      ENDIF
      RETURN
 9000 FORMAT(/,'WARNING: A RATHER ',A5,' NUMBER OF',
     &     ' CONTINUATION STEPS (=',I5,')',/,
     &     'WAS TAKEN LOOKING FOR THE ',
     &     A25,/,'TO AVOID ',A28,' IT MIGHT BE',
     &     ' HELPFUL TO',/,A8,' THE RELEVANT',
     &     ' ds, dsmin AND dsmax',
     &     ' IN constants.input.',/)
      END
