C+    find_stst_ranges.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM IS RUN BY bd.script IF THE WAVE SPEED IS
C+    THE BIFURCATION PARAMETER. IT SCANS ACROSS THE CONTROL
C+    PARAMETER RANGE GIVEN IN parameter_range.input, IDENTIFYING
C+    THOSE PARTS FOR WHICH A STEADY EXISTS.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      LOGICAL EXIST1,EXIST2
      PARAMETER (NPTW= 
C     Note that the value of NPTW is added by the calling script
      DIMENSION U(NPTW)
C-----
      OPEN(13,FILE='../temp_files/parameter_range.input'
     &,STATUS='OLD')
      REWIND(13)
      READ(13,*)PPMIN,PPMAX
      READ(13,*)CMIN,CMAX
      CLOSE(13)
C-----
      NDIM=NPTW
C-----
      NTEST=100
C     THIS IS THE NUMBER OF POINTS OVER THE CONTROL PARAMETER
C     RANGE AT WHICH THE EXISTENCE OF THE STEADY STATE IS TESTED.
C     IT SHOULD BE LARGE ENOUGH THAT ALL RANGES IN WHICH THE STEADY
C     STATE EXISTS ARE DETECTED, MORE OR LESS IN FULL. HOWEVER IT 
C     SHOULD NOT BE TOO LARGE, OTHERWISE THE CALCULATED RANGE END POINTS 
C     WILL BE TOO CLOSE TO THE BOUNDARY OF THE REGION IN WHICH THE 
C     STEADY STATE EXISTS, WHICH CAN CAUSE PROBLEMS GETTING STARTED WITH
C     THE NUMERICAL CONTINUATION OF THE STEADY STATE.
C     THE CHOICE OF 1000 IS ARBITRARY, BUT SHOULD BE SUITABLE IN PRACTICE.
      EXIST1=.FALSE.
      OPEN(15,file='../temp_files/bd.rangelist'
     &,STATUS='NEW')
      PPSTRT=PPMIN
C     Note: the above initialisation of PPSTRT should never be needed
      NSTST=0
      DPP=(PPMAX-PPMIN)/(NTEST-1)
      DO 100 ITEST=1,NTEST
         PP=PPMIN+(ITEST-1)*DPP
         C=CMIN
C        Note: the value assigned to C is irrelevant,
C              but it is good practice to assign some value
         EXIST2=.TRUE.
         CALL STST(NDIM,PP,C,U,EXIST2)
         IF ((.NOT.EXIST1).AND.(EXIST2)) THEN
            IF (ITEST.EQ.1) THEN
               PPSTRT=PP
            ELSE
               PPSTRT=PP+0.3D0*DPP
            ENDIF
         ENDIF
         IF ((EXIST1).AND.(.NOT.EXIST2)) THEN
            PPEND=PP-1.3D0*DPP
            WRITE(15,9000)PPSTRT,PPEND
            NSTST=NSTST+1
         ENDIF
C        Note: in both cases the assigned value of PP
C              is one for which a steady state exists.
C              The 0.3*DPP is included to move the limits
C              slightly away from the end of the steady
C              state range; otherwise there can be problems
C              getting started with the continuation of the
C              steady state.
         EXIST1=EXIST2
 100  CONTINUE
      IF (EXIST2) THEN
         WRITE(15,9000)PPSTRT,PPMAX
         NSTST=NSTST+1
      ENDIF
      CLOSE(15)
      OPEN(16,
     &file='../temp_files/find_stst_ranges.nstst'
     &,STATUS='NEW')
      WRITE(16,9001)NSTST
      CLOSE(16)
C-----
      STOP
 9000 FORMAT(2E18.10E2)
 9001 FORMAT(I8)
      END
