C+    is_direction_ok.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    IF iwave>1, THIS PROGRAM IS RUN AFTER THE RUN OF AUTO USING
C+    INPUT FILE r.ptw.33, TO CHECK WHETHER THE CONTINUATION HAS 
C+    GONE IN THE CORRECT DIRECTION. IF NOT, THE AUTO INPUT FILES 
C+    r.ptw.22 AND r.ptw.33 ARE REWRITTEN WITH THE SIGNS OF ds 
C+    ALTERED (AND NO OTHER CHANGES).
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      CHARACTER*1 AOK
      CALL GINFO(INFO)
      OPEN(11,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)
      READ(11,*)
      READ(11,*)
      READ(11,*)NMXHB,NMXPTW,NMXBD,NMXSP,NMXSB,NMXDUM
      CLOSE(11)
C-----
C     First read in the pp values that specify the correct direction
      OPEN(15,FILE='../temp_files/update_ptw_rfiles.output',
     &STATUS='OLD')
      REWIND(15)
      READ(15,*)PPSTRT,PPRWAY
      CLOSE(15)
C-----
C     Now read in the auto output file
      OPEN(12,FILE='fort.7',
     &STATUS='OLD')
      REWIND(12)
      DO 600 I=1,12
         READ(12,*,END=103)
 600  CONTINUE
      DO 100 I=1,NMXPTW+1
         READ(12,*,END=101)IDUMMY,IPT,ITY,ILAB,PPNEW
 100  CONTINUE
C-----
      CLOSE(12)
      OPEN(66,FILE='../temp_files/fortran.error',
     &STATUS='OLD')
      REWIND(66)
      WRITE(66,'(''ERROR: END OF LOOP 100 IN is_direction_ok.f'')')
      CLOSE(66)
      AOK='n'
      WRITE(6,9000)AOK
      CALL ISTOP(INFO)
C-----
 103  CLOSE(12)
      OPEN(66,FILE='../temp_files/fortran.error',
     &STATUS='OLD')
      REWIND(66)
      WRITE(66,'(''ERROR: FILE 12 HAS INSUFFICIENT OUTPUT'',
     &     ''       LINES in is_direction_ok.f'')')
      CLOSE(66)
      CLOSE(12)
      AOK='n'
      WRITE(6,9000)AOK
      CALL ISTOP(INFO)
C-----
 101  CLOSE(12) 
C     Auto output file is ok, now check direction
      IF (((PPSTRT-PPNEW)*(PPSTRT-PPRWAY)).GT.0.0D0) THEN
         AOK='y'
      ELSE
         AOK='n'
C        Direction wrong so rewrte auto files
         OPEN(20,FILE='r.ptw.22',
     &STATUS='OLD')
         REWIND(20)
         OPEN(22,FILE='../temp_files/r.ptw.22new',
     &STATUS='NEW')
         OPEN(30,FILE='r.ptw.33',
     &STATUS='OLD')
         REWIND(30)
         OPEN(33,FILE='../temp_files/r.ptw.33new',
     &STATUS='NEW')
         DO 400 IWHICH=2,3
            IIP=IWHICH*10
            IOP=IWHICH*11
            READ(IIP,*)I1,I2,I3,I4
            WRITE(IOP,'(I8,I2,I8,I2)')I1,I2,I3,I4
            READ(IIP,*)I1,I2,I3
            WRITE(IOP,'(3I8)')I1,I2,I3
            READ(IIP,*)I1,I2,I3,I4,I5,I6,I7,I8
            WRITE(IOP,'(I8,5I2,2I8)')I1,I2,I3,I4,I5,I6,I7,I8
            READ(IIP,*)I1,R1,R2,R3,R4
            WRITE(IOP,'(I8,4E16.8E2)')I1,R1,R2,R3,R4
            READ(IIP,*)I1,I2,I3,I4,I5,I6,I7
            WRITE(IOP,'(I8,6I3)')I1,I2,I3,I4,I5,I6,I7
            READ(IIP,*)R1,R2,R3
            WRITE(IOP,'(3E16.8E2)')R1,R2,R3
            READ(IIP,*)R1,R2,R3,I1
            WRITE(IOP,'(3E16.8E2,I3)')((-1)*R1),R2,R3,I1
            READ(IIP,*)I1
            WRITE(IOP,'(I8)')I1
            READ(IIP,*)I1,R1
            WRITE(IOP,'(I8,E16.8E2)')I1,R1
            READ(IIP,*)I1
            WRITE(IOP,'(I8)')I1
            READ(IIP,*)I1
            WRITE(IOP,'(I8)')I1
            READ(IIP,*)I1,R1
            WRITE(IOP,'(I8,E16.8E2)')I1,R1
            IF (IWHICH.EQ.3) THEN
               READ(IIP,*)I1,R1
               WRITE(IOP,'(I8,E16.8E2)')I1,R1
            ENDIF
            CLOSE(IIP)
            CLOSE(IOP)
 400     CONTINUE
      ENDIF
C-----
      WRITE(6,9000)AOK
C     screen output not "message": feeds into a pipe
C-----
      CALL ISTOP(INFO)
 9000 FORMAT(A1)
      END
