C+    newwavetest.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM READS IN THE L2-NORM AND PERIOD OF THE PERIODIC 
C+    TRAVELLING WAVE SOLUTION FOR THE END POINT OF THE LAST NUMERICAL
C+    CONTINUATION. IF THE FIRST LINE OF newwavetest.input IS 1, IT 
C+    THEN ASSESSES WHETHER THIS PTW IS THE SAME AS THE LAST PTW
C+    FOUND ALONG THE SOLUTION BRANCH FOR THE GIVEN PARAMETER VALUE.
C+    FINALLY IT REWRITE newwavetest.input IN PREPARATION FOR A 
C+    SUBSEQUENT RUN.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      DIMENSION DARRAY(5)
      CALL GINFO(INFO)
      OPEN(11,FILE='../temp_files/newwavetest.input1'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*,END=701)IDUMMY,WVFRAC
      GOTO 702
 701  WVFRAC=0.001D0
C     The above line sets the default value: wavefrac is
C     an optional entry in constants.input 
 702  CLOSE(11)
C     Now read in NMX values from defaults.input
      OPEN(13,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      REWIND(13)
      READ(13,*)
      READ(13,*)
      READ(13,*)
      READ(13,*)NMXHB,NMXPTW,NMXBD,NMXSP,NMXSB,NMXDUM
      CLOSE(13)
C     Now read in NPTW
      OPEN(18,FILE='../temp_files/variables.numbers'
     &,STATUS='OLD')
      REWIND(18)
      READ(18,*)NPDE
      READ(18,*)NPTW
      CLOSE(18)
C     Now read in the auto output file
      IARRAY=MIN(5,NPTW)
C     The significance of iarray is that in the "fort.7" file,
C     auto prints up to 5 variable values between the norm and
C     the period
      OPEN(12,FILE='fort.7'
     &,STATUS='OLD')
      REWIND(12)
      DO 100 I=1,12
         READ(12,*,END=103)
 100  CONTINUE
      DO 200 I=1,NMXPTW+1
         READ(12,*,END=201)IDUMMY,IPT,ITY,ILAB,PP,RNORM,
     &        (DARRAY(JARRAY),JARRAY=1,IARRAY),PERIOD
 200  CONTINUE
      CLOSE(12)
      OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
      WRITE(66,'(''ERROR: END OF LOOP 200 IN newwavetest.f'')')
      CLOSE(66)
      CALL IOUT(INFO,'error')
      CALL ISTOP(INFO)
 103  CLOSE(12)
      OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
      WRITE(66,'(''ERROR: FILE 12 HAS NO REAL OUTPUT'',
     &     '' LINES in newwavetest.f'')')
      CLOSE(66)
      CALL IOUT(INFO,'error')
      CALL ISTOP(INFO)
 201  CONTINUE
      OPEN(14,FILE='../temp_files/newwavetest.input'
     &,STATUS='OLD')
      REWIND(14)
      READ(14,*)INPUT1
      IF (INPUT1.EQ.1) THEN
         READ(14,*)RNOLD,PROLD
         RNFRAC=ABS(RNORM-RNOLD)*2.0D0/(RNORM+RNOLD)
         PRFRAC=ABS(PERIOD-PROLD)*2.0D0/(PERIOD+PROLD)
C        IRPEAT=1 means that the solution is a repeat
C        IRPEAT=2 means that the solution is new
         IF ((RNFRAC.LT.WVFRAC).AND.(PRFRAC.LT.WVFRAC)) THEN
            IRPEAT=1
            OPEN(16,FILE='../temp_files/outcome.data'
     &,STATUS='OLD')
            REWIND(16)
            WRITE(16,9002)
            CLOSE(16)
C           Note that ../temp_files/outcome.data already
C           exists: it was created by detect_ptw_test.
C           The above lines over-write the outcome code.
         ELSE
            IRPEAT=2
         ENDIF
      ELSE
         IRPEAT=2
      ENDIF
      REWIND(14)
      WRITE(14,9000)RNORM,PERIOD
      CLOSE(14)
      OPEN(15,FILE='../temp_files/newwavetest.output'
     &,STATUS='NEW')
      REWIND(15)
      WRITE(15,9001)IRPEAT
      CLOSE(15)
      STOP
 9000 FORMAT(X,'1',/,2E18.10E2)
 9001 FORMAT(I2)
 9002 FORMAT(X,'43')
      END
