C+    check_direction_hopf.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    SOMETIMES THE INITIAL CONTINUATION STAGE ENDS UP GOING
C+    IN THE NEGATIVE GAMMA DIRECTION EVEN THOUGH A POSITIVE
C+    INITIAL STEP IS GIVEN. THIS IS DUE TO INACCURACIES IN THE
C+    PERIODIC EIGENVALUE WHICH CAN CAUSE AUTO STRUGGLE TO GET
C+    ONTO THE TRUE SPECTRUM. THIS PROGRAM CHECKS WHETHER A
C+    CHANGE IN THE CONTINUATION DIRECTION HAS OCCURRED, AND 
C+    IF IT HAS, ALTERS THE SIGN OF THE INITIAL STEP IN THE
C+    THE RUN FILE FOR THE FOURTH OF THE FOUR CONTINATION STAGES.
C+    NOTE THAT THIS VERSION OF THE PROGRAM IS FOR USE WHEN
C+    LOCATING THE FOLD IN THE SPECTRUM (EXCLUDING THE ORIGIN)
C+    WITH LARGEST REAL PART, WHICH IS PART OF THE INITIAL STAGE
C+    OF FINDING A STABILITY BOUNDARY OF HOPF TYPE. THEREFORE IT
C+    REWRITES r.spectrum.6.
C++
      IMPLICIT REAL*8 (A-H,K,O-Z)
      CALL GINFO(INFO)
C-----
      OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='NEW')
      WRITE(66,'(''DIRECTION CHECKING BY check_direction_hopf.f:'')')
      CLOSE(66)
      CALL IOUT(INFO,'minor')
C-----
      OPEN(11,FILE='../temp_files/defaults.input'
     &,STATUS='OLD')
      REWIND(11)
      READ(11,*)
      READ(11,*)
      READ(11,*)
      READ(11,*)NMXHB,NMXPTW,NMXBD,NMXSP,NMXSB,NMXDUM
      CLOSE(11)
      OPEN(12,FILE='p.spectrumstage2'
     &,STATUS='OLD')
      REWIND(12)
      DO 100 I=1,12
         READ(12,*)IDUMMY
 100  CONTINUE
      DO 200 I=1,NMXSP+1
         READ(12,*,END=201)IDUMMY,IPT,ITY,ILAB,GAMMA
 200  CONTINUE
      CLOSE(12)
      OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='OLD')
      REWIND(66)
      WRITE(66,'(
     &''ERROR: LOOP 200 FINISHED in check_direction_hopf.f'')
     &')
      CLOSE(66)
      CALL IOUT(INFO,'error')
      CALL ISTOP(INFO)
 201  CONTINUE
      CLOSE(12)
C-----
      OPEN(66,FILE='../temp_files/message.txt'
     &,STATUS='OLD')
      REWIND(66)
      IF (GAMMA.GT.0.0D0) THEN
         ISIGN=1
         WRITE(66,'(''DIRECTION IS OK'')')
      ELSE
         ISIGN=-1
         WRITE(66,'(''DIRECTION HAS REVERSED: ALTERING SIGN OF'')')
         WRITE(66,'(''DS IN THE THIRD CONTINUATION STAGE'')')
      ENDIF
      CLOSE(66)
      CALL IOUT(INFO,'minor')
C-----
      OPEN(20,FILE='../loci/data_files/r.spectrum.6'
     &,STATUS='OLD')
      REWIND(20)
      OPEN(21,FILE='../spectrum/r.spectrum.5'
     &,STATUS='NEW')
      READ(20,*)I1,I2,I3,I4
      WRITE(21,'(I8,I2,I8,I2)')I1,I2,I3,I4
      READ(20,*)I1,I2,I3,I4,I5,I6
      WRITE(21,'(6I8)')I1,I2,I3,I4,I5,I6
      READ(20,*)I1,I2,I3,I4,I5,I6,I7,I8
      WRITE(21,'(I8,5I2,2I8)')I1,I2,I3,I4,I5,I6,I7,I8
      READ(20,*)I1,R1,R2,R3,R4
      WRITE(21,'(I8,4E16.8E2)')I1,R1,R2,R3,R4 
      READ(20,*)I1,I2,I3,I4,I5,I6,I7
      WRITE(21,'(I8,6I3)')I1,I2,I3,I4,I5,I6,I7
      READ(20,*)R1,R2,R3
      WRITE(21,'(3F20.10)')R1,R2,R3
      READ(20,*)R1,R2,R3,I1
      WRITE(21,'(3F20.10,I3)')(ISIGN*R1),R2,R3,I1
      READ(20,*)I1
      WRITE(21,'(I8)')I1
      READ(20,*)I1
      WRITE(21,'(I8)')I1
      READ(20,*)I1
      WRITE(21,'(I8)')I1
 300  CLOSE(20)
      CLOSE(21)
C-----
      CALL ISTOP(INFO)
      END
