C+    spectrum_part.f
C This file was written by Jonathan A. Sherratt
C Copyright (C) 2011 Heriot-Watt University, Edinburgh, UK
C  
C THIS FILE IS PART OF WAVETRAIN.
C WAVETRAIN SOFTWARE IS INTENDED FOR FREE PERSONAL PRIVATE 
C AND ACADEMIC USE ONLY AND WAS DEVELOPED BY JONATHAN SHERRATT AT 
C HERIOT-WATT UNIVERSITY, EDINBURGH, UK, AND IS PROTECTED BY COPYRIGHT. 
C THE COPYRIGHT OWNER IS HERIOT-WATT UNIVERSITY, WITH THE EXCEPTION OF 
C THE ROUTINES FROM THE PACKAGES AUTO, BLAS, EISPACK, LAPACK AND MINPACK, 
C WHICH ARE INCLUDED WITH PERMISSION, WHICH ARE CLEARLY IDENTIFIED IN 
C THE SOURCE CODE, AND THE USE OF THESE PACKAGES IS UNDER THE CONDITIONS 
C OF THE ORIGINAL OWNERS WHICH ARE AVAILABLE AT 
C http://www.netlib.org/blas/faq.html#2;
C http://www.netlib.org/lapack/#_licensing; 
C http://www.netlib.org/minpack/disclaimer.
C 
C PERSONS OR ORGANISATIONS WISHING TO USE THIS WAVETRAIN SOFTWARE FOR 
C COMMERCIAL PURPOSES OR PURPOSES OTHER THAN ITS ORIGINAL INTENTION 
C SHOULD CONTACT THE OWNERS TO REQUEST SPECIFIC WRITTEN PERMISSIONS.
C 
C DISTRIBUTION: DISTRIBUTION OF WAVETRAIN SOFTWARE, IN PART OR AS 
C A WHOLE, BY ANY MEANS (ELECTRONIC, PRINTED COPY OR OTHERWISE), IS 
C PROHIBITED WITHOUT THE PRIOR WRITTEN PERMISSION OF EITHER HERIOT-WATT 
C UNIVERSITY OR THE AUTHOR JONATHAN A. SHERRATT. ALL REQUESTS FOR SUCH 
C PERMISSION SHOULD BE SENT BY EMAIL TO J.A.SHERRATT@HW.AC.UK; PLEASE 
C INCLUDE THE WORD WAVETRAIN IN THE SUBJECT HEADING OF THE MESSAGE.  
C 
C WARRANTY LIMITATIONS: THE PRODUCT AND SERVICE ARE PROVIDED "AS IS". 
C THE OWNER DISCLAIMS ANY AND ALL WARRANTIES, INCLUDING BUT NOT LIMITED 
C TO, ALL EXPRESSED OR IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
C FOR A PARTICULAR PURPOSE. UNDER NO CIRCUMSTANCES WILL THE OWNER BE 
C LIABLE TO YOU FOR ANY LOSS OF USE, INTERRUPTION OF BUSINESS OR ANY 
C DIRECT, INDIRECT, SPECIAL, INCIDENTAL, AND/OR CONSEQUENTIAL DAMAGES 
C OF ANY KIND (INCLUDING LOSS OF PROFITS) EVEN IF THE OWNER HAS BEEN 
C ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE OWNER ACCEPTS NO LEGAL 
C LIABILITY FOR ANY OF THE PRODUCT AND/OR SERVICE SOLD, OFFERED FOR SALE, 
C OR OTHERWISE MADE AVAILABLE FOR PUBLIC OR PRIVATE CONSUMPTION IN 
C RELATION TO THIS SOFTWARE. THE OWNER DOES NOT WARRANT THAT THIS SOFTWARE 
C WILL BE ERROR-FREE.
C  
C+    THIS PROGRAM IS COMBINED WITH equations.f TO FORM THE MAIN
C+    AUTO PROGRAM FOR EIGENVALUE SPECTRUM CALCULATIONS.
C++
C----------------------------------------------------------------------
      SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION U(NDIM), PAR(*), F(NDIM), ICP(*)
      DIMENSION UPTW(NDIM/3),DUPTWZ(NDIM/3)
      DIMENSION UEFNR(NDIM/3),UEFNI(NDIM/3)
      DIMENSION AMATRX(NDIM/3,NDIM/3),BMATRX(NDIM/3,NDIM/3)
      NPTW=NDIM/3
      PP=PAR(1)
      C=PAR(2)
      PERIOD=PAR(3)
      GAMMA=PAR(4)
      EVALR=PAR(5)
      EVALI=PAR(6)
      DO 110 I=1,NPTW
         UPTW(I)=U(I)
 110  CONTINUE
      CALL TWEQS(NPTW,PP,C,UPTW,DUPTWZ)
      DO 210 I=1,NPTW
         F(I)=PERIOD*DUPTWZ(I)
 210  CONTINUE
      DO 120 I=1,NPTW
         UEFNR(I)=U(2*I+NPTW-1)
         UEFNI(I)=U(2*I+NPTW)
 120  CONTINUE
      CALL EFEQNS(NPTW,PP,C,UPTW,AMATRX,BMATRX)
      DO 220 I=1,NPTW
         DUEFZR=0.0D0
         DUEFZI=0.0D0
         DO 221 J=1,NPTW
            DUEFZR=DUEFZR+PERIOD*(
     &           (AMATRX(I,J)+EVALR*BMATRX(I,J))*UEFNR(J)
     &           -EVALI*BMATRX(I,J)*UEFNI(J))
            DUEFZI=DUEFZI+PERIOD*(
     &           +(AMATRX(I,J)+EVALR*BMATRX(I,J))*UEFNI(J)
     &           +EVALI*BMATRX(I,J)*UEFNR(J))
 221     CONTINUE
         F(2*I+NPTW-1)=DUEFZR
         F(2*I+NPTW)=DUEFZI
 220  CONTINUE
      RETURN
      END
C----------------------------------------------------------------------
      SUBROUTINE STPNT(NDIM,U,PAR)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION U(NDIM), PAR(*)
      OPEN(12,FILE='../ptwcalc/data_files/ptw.params'
     &,STATUS='OLD')
      REWIND(12)
      READ(12,*)PP,C,PERIOD
      CLOSE(12)    
      PAR(1)=PP
      PAR(2)=C
      PAR(3)=PERIOD
      PAR(4)=0.0D0
      OPEN(13,FILE='data_files/spectrum.evalue'
     &,STATUS='OLD')
      REWIND(13)
      READ(13,*)PAR(5),PAR(6)
      CLOSE(13)
C     NOTE: SOLUTION IS INITIALISED BY READING IN PTW SOLUTION 
C           FROM A FILE USING THE @fc COMMAND
      RETURN
      END
C----------------------------------------------------------------------
      SUBROUTINE BCND(NDIM,PAR,ICP,NBC,U0,U1,FB,IJAC,DBC) 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION PAR(*),ICP(*),U0(NDIM),U1(NDIM),FB(NBC)
      NPTW=NDIM/3
      GAMMA=PAR(4)
      CG=COS(GAMMA)
      SG=SIN(GAMMA)
      DO 100 I=1,NPTW
         FB(I)=U0(I)-U1(I)
         JR=NPTW+2*I-1
         JI=JR+1
         FB(JR)=-U1(JR)+U0(JR)*CG-U0(JI)*SG
         FB(JI)=-U1(JI)+U0(JI)*CG+U0(JR)*SG
 100  CONTINUE
C     NOTE: u(jr) AND u(ji) ARE THE REAL AND IMAGINARY 
C           PARTS OF THE EIGENFUNCTION CORRESPONDING TO 
C           THE iTH TRAVELLING WAVE VARIABLE.
      RETURN 
      END 
C----------------------------------------------------------------------
      SUBROUTINE ICND(NDIM,PAR,ICP,NINT,U,UOLD,UDOT,UPOLD,FI,IJAC,DINT)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION U(NDIM),UOLD(NDIM),UDOT(NDIM),UPOLD(NDIM)
      DIMENSION FI(NINT),DINT(NINT,*),ICP(*),PAR(*)
      NPTW=NDIM/3
      FI(1)=0.0D0
      FI(2)=-1.0D0
      FI(3)=0.0D0
      DO 100 I=1,NPTW
         FI(1)=FI(1)+UPOLD(I)*(UOLD(I)-U(I))
         JR=NPTW+2*I-1
         JI=JR+1
         FI(2)=FI(2)+U(JR)*U(JR)+U(JI)*U(JI)
         FI(3)=FI(3)+UOLD(JR)*U(JI)-UOLD(JI)*U(JR)
 100  CONTINUE
C     NOTE: u(jr) AND u(ji) ARE THE REAL AND IMAGINARY 
C           PARTS OF THE EIGENFUNCTION CORRESPONDING TO 
C           THE iTH TRAVELLING WAVE VARIABLE.
      RETURN 
      END 
C----------------------------------------------------------------------
      SUBROUTINE FOPT 
      RETURN 
      END 
C----------------------------------------------------------------------
      SUBROUTINE PVLS
      RETURN 
      END 
C----------------------------------------------------------------------
